﻿package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.geom.Rectangle;
	
	
	public class Spectre extends Sprite{
		
		private var _son:Sound;
		private var _canal:SoundChannel;
		private var _grapheSpectre:BitmapData;
		
		public function Spectre(sound:String){
			//_grapheSpectre = new BitmapData(600,600,false,0x00000000);
			_grapheSpectre = new BitmapData(1440,900,false,0xffffffff);
			var bitmap:Bitmap = new Bitmap(_grapheSpectre);
			addChild(bitmap);
			//bitmap.x=20;
			bitmap.x=-395;
			//bitmap.y=20;
			bitmap.y=-140;
			
			
			_son = new Sound(new URLRequest(sound));
			_canal = _son.play();
		
			addEventListener(Event.ENTER_FRAME, onEnterFrame);		
		}
		
		private function onEnterFrame(evenement:Event):void{
			//Crée le tableau d'octets et le remplit de données
			var spectre:ByteArray = new ByteArray();
			SoundMixer.computeSpectrum(spectre);
			
			//Effacer le bitmap
			//_grapheSpectre.fillRect(_grapheSpectre.rect,0x00000000);
			_grapheSpectre.fillRect(_grapheSpectre.rect,0xff017d);
			
			//_posx=75;
			_posx=40;
			//_posy=50;
			_posy=50;
			//Canal gauche
			//for(var i:int=0;i<256;i++){
			for(var i:int=0;i<120;i++){
				//_grapheSpectre.setPixel32(i,20+spectre.readFloat()*20,0xffffffff);
				
				
				//val=spectre.readFloat()*20;
				val=spectre.readFloat()*300;
				//_rect= new Rectangle(_posx-val,_posy+(i*2),200,1);
				_rect= new Rectangle(_posx+200-val,_posy-100+(i*20),500,10);
				//_grapheSpectre.fillRect(_rect,0xffffff);
				_grapheSpectre.fillRect(_rect,0x0);
			}
				
			//Canal droit
			for(var j:int=0;j<256;j++){
				//_grapheSpectre.setPixel32(j,40+spectre.readFloat()*40,0xffffffff);
				
				//val2=spectre.readFloat()*40;
				val2=spectre.readFloat()*500;
				//_rect2= new Rectangle(_posx+250-val2,_posy+(j*2),100,1);
				_rect2= new Rectangle(_posy+800-val2,_posx-50+(j*69),400,40)
				//_grapheSpectre.fillRect(_rect2,0xffffff);
				_grapheSpectre.fillRect(_rect2,0xfffff000 );
				
			}
		}
	}
	
}